Program PatInst;

const
   HEXArray           : Array [0..15] of char = ('0','1','2','3','4','5','6','7',
                                                 '8','9','A','B','C','D','E','F');
var
   TSRPAT             : file;
   INDEX              : text;
   BUF                : array [0..255] of byte;
   Integ,i,j          : Integer;
   CMD                : String;
   SuchLen,PatchLen   : Byte;
   PatchOffset        : Word;
   TSRCounter         : Integer;

Function HEX(b : char) : byte;
begin
  for j:=0 to 15 do
    if HEXArray[j] = UpCase(b) then HEX := j;
end;

Procedure DoPatchConvert;
begin
   Writeln('Accessing ',ParamStr(1));
   assign(TSRPAT,'TSR-PAT.COM');               { INDEX Start at Offset 9 }
   if Pos('.',ParamStr(1))>0 then assign(INDEX,ParamStr(1)) else assign(INDEX,ParamStr(1)+'.PAT');
   reset(TSRPAT,1);
   reset(INDEX);
   repeat
     Readln(INDEX,CMD);
     IF Copy (CMD, 1,14) = 'SEARCHSTRING =' then
     begin
       TSRCounter:=0;
       Writeln('Suchstringdata found.');
       seek(TSRPAT,9);
       SuchLen := (length(CMD) - 14) div 2;
       BUF[0]:=Suchlen;
       inc(TSRCounter);
       For i := 1 to Suchlen*2 do
       begin
         BUF[TSRCounter]:=HEX(CMD[15+i])*16+HEX(CMD[15+i+1]);
         inc(i);
         inc(TSRCounter);
       end;
       Writeln('Suchstringlnge = ',SuchLen,'.');
       BUF[TSRCounter]:=35;
       BUF[TSRCounter+1]:=35;
       inc(TSRCounter,2);
       BlockWrite(TSRPAT,BUF,TSRCounter,Integ);
       seek(TSRPAT,40);
     end;

   IF Copy (CMD, 1,7) = 'PATCH =' then
     begin                                { 40 }
       TSRCounter:=0;
       VAL(Copy(CMD,8,Pos(',',CMD)-8),PatchOffset,Integ);
       PatchLen := (length(CMD) - Pos(',',CMD)) div 2;
       Writeln('Patchdata found: ',PatchLen,' Bytes at Offset ',PatchOffset);
       BUF[0]:=PatchOffset mod 256;
       BUF[1]:=PatchOffset div 256;
       BUF[2]:=PatchLen;
       inc(TSRCounter,3);

       For i := 1 to PatchLen*2 do
       begin
         BUF[TSRCounter]:=HEX(CMD[Pos(',',CMD)+i])*16+HEX(CMD[Pos(',',CMD)+i+1]);
         inc(i);
         inc(TSRCounter);
       end;
       BlockWrite(TSRPAT,BUF,TSRCounter,Integ);
     end;

   until EOF(INDEX);
   for i:=0 to 4 do BUF[i]:=0;
   BlockWrite(TSRPAT,BUF,i,Integ);
   close(TSRPAT);

end;

Procedure Help;
begin
  Writeln;
  Writeln('PAT-INST was written 4 the TSR-Patcher by Alexander Gaupp.');
  Writeln('It''s designed to modify the search and patch options in TSR-PAT.COM');
  Writeln;
  Writeln('An indexfile is build the following way:');
  Writeln('first Line: SEARCHSTRING = xxxxxxxxxxxxxx in hex values ');
  Writeln('next ones : PATCH = patchoffset,xxxxxxxxx in hex values ');
  Writeln;
  Writeln('You can just search for 1 searchstring!, and the beginning of this');
  Writeln('DATA-Area is a new segment with offset 0000 !');
  Writeln('with the '';'' you can insert annotation lines.');
  Writeln;
  Writeln('an Example:');
  Writeln('; patch for test purposes ... ');
  Writeln('SEARCHSTRING = 4B4C41555349          will search for ''KLAUSI'' ');
  Writeln('PATCH = 0,204D                       will patch offset 0 to '' M'' ');
  Writeln('                                     the data at Seg:0 is now '' MAUSI'' ');
  Writeln('PATCH = 201,9090                     will insert two NOPs (90) at');
  Writeln('                                     searchstring+201 (Seg:201) ');
  Writeln;
  Writeln('If you haven''t understood my explanations better don''t use TSR-PAT!');
  Writeln('For information cantact 2:247/1307.15');
end;

begin
  Writeln;
  Writeln;
  Writeln('PAT-INST V.01 public');
  Writeln;
  if ParamStr(1) = '' then Writeln('PAT-INST [<indexfile>].PAT [/?] ')
  else
    begin
      If (ParamStr(1) = '/?') or (ParamStr(1) = '-?') then Help
       else DoPatchConvert;
    end;
  Writeln('95 by alx');
end.